Index: LMDZ5/trunk/libf/dyn3d/dynetat0.f90
===================================================================
--- LMDZ5/trunk/libf/dyn3d/dynetat0.f90	(revision 2299)
+++ LMDZ5/trunk/libf/dyn3d/dynetat0.f90	(revision 2299)
@@ -0,0 +1,202 @@
+SUBROUTINE dynetat0(fichnom,vcov,ucov,teta,q,masse,ps,phis,time)
+!
+!-------------------------------------------------------------------------------
+! Authors: P. Le Van , L.Fairhead
+!-------------------------------------------------------------------------------
+! Purpose: Initial state reading.
+!-------------------------------------------------------------------------------
+  USE infotrac
+  USE netcdf,      ONLY: NF90_OPEN,  NF90_NOWRITE, NF90_INQ_VARID, NF90_NoErr, &
+                         NF90_CLOSE, NF90_GET_VAR
+  USE control_mod, ONLY: planet_type
+  USE assert_eq_m, ONLY: assert_eq
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "temps.h"
+  include "comconst.h"
+  include "comvert.h"
+  include "comgeom2.h"
+  include "ener.h"
+  include "description.h"
+  include "serre.h"
+  include "logic.h"
+  include "iniprint.h"
+!===============================================================================
+! Arguments:
+  CHARACTER(LEN=*), INTENT(IN) :: fichnom          !--- FILE NAME
+  REAL, INTENT(OUT) ::  vcov(iip1,jjm, llm)        !--- V COVARIANT WIND
+  REAL, INTENT(OUT) ::  ucov(iip1,jjp1,llm)        !--- U COVARIANT WIND
+  REAL, INTENT(OUT) ::  teta(iip1,jjp1,llm)        !--- POTENTIAL TEMP.
+  REAL, INTENT(OUT) ::     q(iip1,jjp1,llm,nqtot)  !--- TRACERS
+  REAL, INTENT(OUT) :: masse(iip1,jjp1,llm)        !--- MASS PER CELL
+  REAL, INTENT(OUT) ::    ps(iip1,jjp1)            !--- GROUND PRESSURE
+  REAL, INTENT(OUT) ::  phis(iip1,jjp1)            !--- GEOPOTENTIAL
+!===============================================================================
+! Local variables:
+  CHARACTER(LEN=256) :: msg, var, modname
+  INTEGER, PARAMETER :: length=100
+  INTEGER :: iq, fID, vID, idecal!, iml, jml, lml, nqt
+  REAL    :: time, tab_cntrl(length)               !--- RUN PARAMS TABLE
+!-------------------------------------------------------------------------------
+  modname="dynetat0"
+
+!--- Initial state file opening
+  var=fichnom
+  CALL err(NF90_OPEN(var,NF90_NOWRITE,fID),"open",var)
+  CALL get_var1("controle",tab_cntrl)
+
+!!! AS: idecal is a hack to be able to read planeto starts...
+!!!     .... while keeping everything OK for LMDZ EARTH
+  IF(planet_type=="generic") THEN
+    WRITE(lunout,*)'NOTE NOTE NOTE : Planeto-like start files'
+    idecal = 4
+    annee_ref  = 2000
+  ELSE
+    WRITE(lunout,*)'NOTE NOTE NOTE : Earth-like start files'
+    idecal = 5
+    annee_ref  = tab_cntrl(5)
+  END IF
+  im         = tab_cntrl(1)
+  jm         = tab_cntrl(2)
+  lllm       = tab_cntrl(3)
+  day_ref    = tab_cntrl(4)
+  rad        = tab_cntrl(idecal+1)
+  omeg       = tab_cntrl(idecal+2)
+  g          = tab_cntrl(idecal+3)
+  cpp        = tab_cntrl(idecal+4)
+  kappa      = tab_cntrl(idecal+5)
+  daysec     = tab_cntrl(idecal+6)
+  dtvr       = tab_cntrl(idecal+7)
+  etot0      = tab_cntrl(idecal+8)
+  ptot0      = tab_cntrl(idecal+9)
+  ztot0      = tab_cntrl(idecal+10)
+  stot0      = tab_cntrl(idecal+11)
+  ang0       = tab_cntrl(idecal+12)
+  pa         = tab_cntrl(idecal+13)
+  preff      = tab_cntrl(idecal+14)
+!
+  clon       = tab_cntrl(idecal+15)
+  clat       = tab_cntrl(idecal+16)
+  grossismx  = tab_cntrl(idecal+17)
+  grossismy  = tab_cntrl(idecal+18)
+!
+  IF ( tab_cntrl(idecal+19)==1. )  THEN
+    fxyhypb  = .TRUE.
+!   dzoomx   = tab_cntrl(25)
+!   dzoomy   = tab_cntrl(26)
+!   taux     = tab_cntrl(28)
+!   tauy     = tab_cntrl(29)
+  ELSE
+    fxyhypb = .FALSE.
+    ysinus  = tab_cntrl(idecal+22)==1.
+  END IF
+
+  day_ini    = tab_cntrl(30)
+  itau_dyn   = tab_cntrl(31)
+  start_time = tab_cntrl(32)
+
+!-------------------------------------------------------------------------------
+  WRITE(lunout,*)TRIM(modname)//': rad,omeg,g,cpp,kappa',rad,omeg,g,cpp,kappa
+  CALL check_dim(im,iim,'im','im')
+  CALL check_dim(jm,jjm,'jm','jm')
+  CALL check_dim(lllm,llm,'lm','lllm')
+  CALL get_var1("rlonu",rlonu)
+  CALL get_var1("rlatu",rlatu)
+  CALL get_var1("rlonv",rlonv)
+  CALL get_var1("rlatv",rlatv)
+  CALL get_var2("cu"   ,cu)
+  CALL get_var2("cv"   ,cv)
+  CALL get_var2("aire" ,aire)
+  var="temps"
+  IF(NF90_INQ_VARID(fID,var,vID)/=NF90_NoErr) THEN
+    WRITE(lunout,*)TRIM(modname)//": missing field <temps>"
+    WRITE(lunout,*)TRIM(modname)//": trying with <Time>"; var="Time"
+    CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
+  END IF
+  CALL err(NF90_GET_VAR(fID,vID,time),"get",var)
+  CALL get_var2("phisinit",phis)
+  CALL get_var3("ucov",ucov)
+  CALL get_var3("vcov",vcov)
+  CALL get_var3("teta",teta)
+  CALL get_var3("masse",masse)
+  CALL get_var2("ps",ps)
+
+!--- Tracers
+  DO iq=1,nqtot
+    var=tname(iq)
+    IF(NF90_INQ_VARID(fID,var,vID)==NF90_NoErr) THEN
+      CALL err(NF90_GET_VAR(fID,vID,q(:,:,:,iq)),"get",var); CYCLE
+    END IF
+    WRITE(lunout,*)TRIM(modname)//": Tracer <"//TRIM(var)//"> is missing"
+    WRITE(lunout,*)"         It is hence initialized to zero"
+    q(:,:,:,iq)=0.
+   !--- CRisi: for isotops, theoretical initialization using very simplified
+   !           Rayleigh distillation las.
+    IF(ok_isotopes.AND.iso_num(iq)>0) THEN
+      IF(zone_num(iq)==0) q(:,:,:,iq)=q(:,:,:,iqpere(iq))*tnat(iso_num(iq))    &
+     &             *(q(:,:,:,iqpere(iq))/30.e-3)**(alpha_ideal(iso_num(iq))-1)
+      IF(zone_num(iq)==1) q(:,:,:,iq)=q(:,:,:,iqiso(iso_indnum(iq),phase_num(iq)))
+    END IF
+  END DO
+
+  CALL err(NF90_CLOSE(fID),"close",fichnom)
+  day_ini=day_ini+INT(time)
+  time=time-INT(time)
+
+
+  CONTAINS
+
+
+SUBROUTINE check_dim(n1,n2,str1,str2)
+  INTEGER,          INTENT(IN) :: n1, n2
+  CHARACTER(LEN=*), INTENT(IN) :: str1, str2
+  CHARACTER(LEN=256) :: s1, s2
+  IF(n1/=n2) THEN
+    s1='value of '//TRIM(str1)//' ='
+    s2=' read in starting file differs from parametrized '//TRIM(str2)//' ='
+    WRITE(msg,'(10x,a,i4,2x,a,i4)'),s1,n1,s2,n2
+    CALL ABORT_gcm(TRIM(modname),TRIM(msg),1)
+  END IF
+END SUBROUTINE check_dim
+
+
+SUBROUTINE get_var1(var,v)
+  CHARACTER(LEN=*), INTENT(IN)  :: var
+  REAL,             INTENT(OUT) :: v(:)
+  CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
+  CALL err(NF90_GET_VAR(fID,vID,v),"get",var)
+END SUBROUTINE get_var1
+
+
+SUBROUTINE get_var2(var,v)
+  CHARACTER(LEN=*), INTENT(IN)  :: var
+  REAL,             INTENT(OUT) :: v(:,:)
+  CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
+  CALL err(NF90_GET_VAR(fID,vID,v),"get",var)
+END SUBROUTINE get_var2
+
+
+SUBROUTINE get_var3(var,v)
+  CHARACTER(LEN=*), INTENT(IN)  :: var
+  REAL,             INTENT(OUT) :: v(:,:,:)
+  CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
+  CALL err(NF90_GET_VAR(fID,vID,v),"get",var)
+END SUBROUTINE get_var3
+
+
+SUBROUTINE err(ierr,typ,nam)
+  INTEGER,          INTENT(IN) :: ierr   !--- NetCDF ERROR CODE
+  CHARACTER(LEN=*), INTENT(IN) :: typ    !--- TYPE OF OPERATION
+  CHARACTER(LEN=*), INTENT(IN) :: nam    !--- FIELD/FILE NAME
+  IF(ierr==NF90_NoERR) RETURN
+  SELECT CASE(typ)
+    CASE('inq');   msg="Field <"//TRIM(nam)//"> is missing"
+    CASE('get');   msg="Reading failed for <"//TRIM(nam)//">"
+    CASE('open');  msg="File opening failed for <"//TRIM(nam)//">"
+    CASE('close'); msg="File closing failed for <"//TRIM(nam)//">"
+  END SELECT
+  CALL ABORT_gcm(TRIM(modname),TRIM(msg),ierr)
+END SUBROUTINE err
+
+END SUBROUTINE dynetat0
Index: LMDZ5/trunk/libf/dyn3d/dynredem.F90
===================================================================
--- LMDZ5/trunk/libf/dyn3d/dynredem.F90	(revision 2298)
+++ LMDZ5/trunk/libf/dyn3d/dynredem.F90	(revision 2299)
@@ -8,8 +8,7 @@
 #endif
   USE infotrac
-  USE netcdf, ONLY:   NF90_CREATE, NF90_DEF_DIM, NF90_REDEF,  NF90_INQ_VARID, &
-      NF90_CLOBBER,   NF90_CLOSE,  NF90_DEF_VAR, NF90_ENDDEF, NF90_PUT_ATT,   &
-      NF90_UNLIMITED, NF90_GLOBAL, NF90_FLOAT,   NF90_DOUBLE
-  USE netcdf95, ONLY: NF95_PUT_VAR
+  USE netcdf, ONLY: NF90_CREATE, NF90_DEF_DIM, NF90_INQ_VARID, NF90_GLOBAL,    &
+                    NF90_CLOSE,  NF90_PUT_ATT, NF90_UNLIMITED, NF90_CLOBBER
+  USE dynredem_mod, ONLY: cre_var, put_var1, put_var2, err, modname, fil
   IMPLICIT NONE
   include "dimensions.h"
@@ -21,5 +20,4 @@
   include "ener.h"
   include "logic.h"
-  include "netcdf.inc"
   include "description.h"
   include "serre.h"
@@ -35,5 +33,4 @@
   INTEGER, PARAMETER :: length=100
   REAL    :: tab_cntrl(length)                     !--- RUN PARAMETERS TABLE
-  CHARACTER(LEN=20) :: modname
 !   For NetCDF:
   CHARACTER(LEN=30) :: unites
@@ -42,7 +39,7 @@
   INTEGER :: sID, sigID, nID, vID, timID
   INTEGER :: yyears0, jjour0, mmois0
-  REAL :: zan0, zjulian, hours
-!===============================================================================
-  modname='dynredem0'
+  REAL    :: zan0, zjulian, hours
+!===============================================================================
+  modname='dynredem0'; fil=fichnom
 #ifdef CPP_IOIPSL
   CALL ymds2ju(annee_ref, 1, iday_end, 0.0, zjulian)
@@ -102,5 +99,4 @@
 ! start_time: start_time of simulation (not necessarily 0.)
   tab_cntrl(32) = start_time
-!.........................................................
 
 !--- File creation
@@ -121,33 +117,32 @@
 
 !--- Define and save invariant fields
-  CALL put_var1("controle","Parametres de controle" ,[indexID],tab_cntrl)
-  CALL put_var1("rlonu"   ,"Longitudes des points U",[rlonuID],rlonu)
-  CALL put_var1("rlatu"   ,"Latitudes des points U" ,[rlatuID],rlatu)
-  CALL put_var1("rlonv"   ,"Longitudes des points V",[rlonvID],rlonv)
-  CALL put_var1("rlatv"   ,"Latitudes des points V" ,[rlatvID],rlatv)
-  CALL put_var1("nivsigs" ,"Numero naturel des couches s"    ,[sID]  ,nivsigs)
-  CALL put_var1("nivsig"  ,"Numero naturel des couches sigma",[sigID],nivsig)
-  CALL put_var1("ap"      ,"Coefficient A pour hybride"      ,[sigID],ap)
-  CALL put_var1("bp"      ,"Coefficient B pour hybride"      ,[sigID],bp)
-  CALL put_var1("presnivs",""                                ,[sID]  ,presnivs)
+  CALL put_var1(nid,"controle","Parametres de controle" ,[indexID],tab_cntrl)
+  CALL put_var1(nid,"rlonu"   ,"Longitudes des points U",[rlonuID],rlonu)
+  CALL put_var1(nid,"rlatu"   ,"Latitudes des points U" ,[rlatuID],rlatu)
+  CALL put_var1(nid,"rlonv"   ,"Longitudes des points V",[rlonvID],rlonv)
+  CALL put_var1(nid,"rlatv"   ,"Latitudes des points V" ,[rlatvID],rlatv)
+  CALL put_var1(nid,"nivsigs" ,"Numero naturel des couches s"    ,[sID]  ,nivsigs)
+  CALL put_var1(nid,"nivsig"  ,"Numero naturel des couches sigma",[sigID],nivsig)
+  CALL put_var1(nid,"ap"      ,"Coefficient A pour hybride"      ,[sigID],ap)
+  CALL put_var1(nid,"bp"      ,"Coefficient B pour hybride"      ,[sigID],bp)
+  CALL put_var1(nid,"presnivs",""                                ,[sID]  ,presnivs)
 ! covariant <-> contravariant <-> natural conversion coefficients
-  CALL put_var2("cu","Coefficient de passage pour U",[rlonuID,rlatuID],cu)
-  CALL put_var2("cv","Coefficient de passage pour V",[rlonvID,rlatvID],cv)
-  CALL put_var2("aire","Aires de chaque maille"     ,[rlonvID,rlatuID],aire)
-  CALL put_var2("phisinit","Geopotentiel au sol"    ,[rlonvID,rlatuID],phis)
+  CALL put_var2(nid,"cu","Coefficient de passage pour U",[rlonuID,rlatuID],cu)
+  CALL put_var2(nid,"cv","Coefficient de passage pour V",[rlonvID,rlatvID],cv)
+  CALL put_var2(nid,"aire","Aires de chaque maille"     ,[rlonvID,rlatuID],aire)
+  CALL put_var2(nid,"phisinit","Geopotentiel au sol"    ,[rlonvID,rlatuID],phis)
 
 !--- Define fields saved later
   WRITE(unites,"('days since ',i4,'-',i2.2,'-',i2.2,' 00:00:00')"),&
                yyears0,mmois0,jjour0
-  CALL put_var0("temps","Temps de simulation",[timID],unites)
-  CALL put_var0("ucov" ,"Vitesse U"  ,[rlonuID,rlatuID,sID,timID])
-  CALL put_var0("vcov" ,"Vitesse V"  ,[rlonvID,rlatvID,sID,timID])
-  CALL put_var0("teta" ,"Temperature",[rlonvID,rlatuID,sID,timID])
+  CALL cre_var(nid,"temps","Temps de simulation",[timID],unites)
+  CALL cre_var(nid,"ucov" ,"Vitesse U"  ,[rlonuID,rlatuID,sID,timID])
+  CALL cre_var(nid,"vcov" ,"Vitesse V"  ,[rlonvID,rlatvID,sID,timID])
+  CALL cre_var(nid,"teta" ,"Temperature",[rlonvID,rlatuID,sID,timID])
   DO iq=1,nqtot
-    CALL put_var0(tname(iq),ttext(iq) ,[rlonvID,rlatuID,sID,timID])
+    CALL cre_var(nid,tname(iq),ttext(iq),[rlonvID,rlatuID,sID,timID])
   END DO
-  CALL put_var0("masse","Masse d air"    ,[rlonvID,rlatuID,sID,timID])
-  CALL put_var0("ps"   ,"Pression au sol",[rlonvID,rlatuID    ,timID])
-  CALL err(NF90_ENDDEF(nid))
+  CALL cre_var(nid,"masse","Masse d air"    ,[rlonvID,rlatuID,sID,timID])
+  CALL cre_var(nid,"ps"   ,"Pression au sol",[rlonvID,rlatuID    ,timID])
   CALL err(NF90_CLOSE (nid))
 
@@ -155,80 +150,4 @@
   WRITE(lunout,*)TRIM(modname)//': rad,omeg,g,cpp,kappa',rad,omeg,g,cpp,kappa
 
-
-CONTAINS
-
-
-SUBROUTINE put_var0(var,title,did,units)
-  CHARACTER(LEN=*),           INTENT(IN) :: var, title
-  INTEGER,                    INTENT(IN) :: did(:)
-  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: units
-#ifdef NC_DOUBLE
-  CALL err(NF90_DEF_VAR(nid,var,NF90_DOUBLE,did,vID),var)
-#else
-  CALL err(NF90_DEF_VAR(nid,var,NF90_FLOAT,did,vID),var)
-#endif
-  IF(title/="")      CALL err(NF90_PUT_ATT(nid,vID,"title",title),var)
-  IF(PRESENT(units)) CALL err(NF90_PUT_ATT(nid,vID,"units",units),var)
-END SUBROUTINE put_var0
-
-
-SUBROUTINE put_var1(var,title,did,v,units)
-  CHARACTER(LEN=*),           INTENT(IN) :: var, title
-  INTEGER,                    INTENT(IN) :: did(1)
-#ifdef NC_DOUBLE
-  DOUBLE PRECISION,           INTENT(IN) :: v(:)
-#else
-  REAL,                       INTENT(IN) :: v(:)
-#endif
-  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: units
-#ifdef NC_DOUBLE
-  CALL err(NF90_DEF_VAR(nid,var,NF90_DOUBLE,did,vID),var)
-#else
-  CALL err(NF90_DEF_VAR(nid,var,NF90_FLOAT,did,vID),var)
-#endif
-  IF(title/="")      CALL err(NF90_PUT_ATT(nid,vID,"title",title),var)
-  IF(PRESENT(units)) CALL err(NF90_PUT_ATT(nid,vID,"units",units),var)
-  CALL err(NF90_ENDDEF(nid))
-  CALL NF95_PUT_VAR(nid,vID,v)
-  CALL err(NF90_REDEF(nid))
-END SUBROUTINE put_var1
-
-
-SUBROUTINE put_var2(var,title,did,v,units)
-  CHARACTER(LEN=*),           INTENT(IN) :: var, title
-  INTEGER,                    INTENT(IN) :: did(2)
-#ifdef NC_DOUBLE
-  DOUBLE PRECISION,           INTENT(IN) :: v(:,:)
-#else
-  REAL,                       INTENT(IN) :: v(:,:)
-#endif
-  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: units
-#ifdef NC_DOUBLE
-  CALL err(NF90_DEF_VAR(nid,var,NF90_DOUBLE,did,vID),var)
-#else
-  CALL err(NF90_DEF_VAR(nid,var,NF90_FLOAT,did,vID),var)
-#endif
-  IF(title/="")      CALL err(NF90_PUT_ATT(nid,vID,"title",title),var)
-  IF(PRESENT(units)) CALL err(NF90_PUT_ATT(nid,vID,"units",units),var)
-  CALL err(NF90_ENDDEF(nid))
-  CALL NF95_PUT_VAR(nid,vID,v)
-  CALL err(NF90_REDEF(nid))
-
-END SUBROUTINE put_var2
-
-
-SUBROUTINE err(ierr,var)
-  USE netcdf, ONLY: NF90_STRERROR, NF90_NOERR
-  IMPLICIT NONE
-  INTEGER,                    INTENT(IN) :: ierr   !--- NetCDF ERROR CODE
-  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: var    !--- VARIABLE NAME
-  CHARACTER(LEN=256) :: file, msg
-  IF(ierr==NF90_NoERR) RETURN
-  msg='Error in "'//TRIM(modname)//'" for file "'//TRIM(fichnom)//'"'
-  IF(PRESENT(var)) msg=TRIM(msg)//'" and variable "'//TRIM(var)//'"'
-  WRITE(lunout,*)TRIM(msg)//': '//NF90_STRERROR(ierr)
-
-END SUBROUTINE err
-
 END SUBROUTINE dynredem0
 !
@@ -245,186 +164,83 @@
   USE infotrac
   USE control_mod
-  USE netcdf,   ONLY: NF90_OPEN,  NF90_NOWRITE, NF90_INQ_VARID, NF90_NoErr,    &
-                      NF90_CLOSE, NF90_WRITE,   NF90_GET_VAR
-  USE netcdf95, ONLY: NF95_PUT_VAR
-  USE assert_eq_m, ONLY: assert_eq
+  USE netcdf,   ONLY: NF90_OPEN,  NF90_NOWRITE, NF90_GET_VAR, NF90_INQ_VARID,  &
+                      NF90_CLOSE, NF90_WRITE,   NF90_PUT_VAR, NF90_NoErr
+  USE dynredem_mod, ONLY: dynredem_write_u, dynredem_write_v, dynredem_read_u, &
+                          err, modname, fil, msg
   IMPLICIT NONE
-#include "dimensions.h"
-#include "paramet.h"
-#include "description.h"
-#include "comvert.h"
-#include "comgeom.h"
-#include "temps.h"
-#include "iniprint.h"
+  include "dimensions.h"
+  include "paramet.h"
+  include "description.h"
+  include "comvert.h"
+  include "comgeom.h"
+  include "temps.h"
+  include "iniprint.h"
 !===============================================================================
 ! Arguments:
-  CHARACTER(LEN=*), INTENT(IN) :: fichnom           !-- FILE NAME
-  REAL, INTENT(IN) ::  time                         !-- TIME
-  REAL, INTENT(IN) ::  vcov(iip1,jjm, llm)          !-- V COVARIANT WIND
-  REAL, INTENT(IN) ::  ucov(iip1,jjp1,llm)          !-- U COVARIANT WIND
-  REAL, INTENT(IN) ::  teta(iip1,jjp1,llm)          !-- POTENTIAL TEMPERATURE
-  REAL, INTENT(IN) ::     q(iip1,jjp1,llm,nqtot)    !-- TRACERS
-  REAL, INTENT(IN) :: masse(iip1,jjp1,llm)          !-- MASS PER CELL
-  REAL, INTENT(IN) ::    ps(iip1,jjp1)              !-- GROUND PRESSURE
+  CHARACTER(LEN=*), INTENT(IN) :: fichnom              !-- FILE NAME
+  REAL, INTENT(IN)    ::  time                         !-- TIME
+  REAL, INTENT(IN)    ::  vcov(iip1,jjm, llm)          !-- V COVARIANT WIND
+  REAL, INTENT(IN)    ::  ucov(iip1,jjp1,llm)          !-- U COVARIANT WIND
+  REAL, INTENT(IN)    ::  teta(iip1,jjp1,llm)          !-- POTENTIAL TEMPERATURE
+  REAL, INTENT(INOUT) ::     q(iip1,jjp1,llm,nqtot)    !-- TRACERS
+  REAL, INTENT(IN)    :: masse(iip1,jjp1,llm)          !-- MASS PER CELL
+  REAL, INTENT(IN)    ::    ps(iip1,jjp1)              !-- GROUND PRESSURE
 !===============================================================================
 ! Local variables:
-  INTEGER :: l, iq, nid, vID, nid_trac, vID_trac
+  INTEGER :: l, iq, nid, vID, ierr, nid_trac, vID_trac
   INTEGER, SAVE :: nb=0
   INTEGER, PARAMETER :: length=100
-#ifdef NC_DOUBLE
-  DOUBLE PRECISION   :: trac_tmp(ip1jmp1,llm)
-#else
-  REAL               :: trac_tmp(ip1jmp1,llm)
-#endif
   REAL               :: tab_cntrl(length) ! tableau des parametres du run
-  CHARACTER(LEN=256) :: modname, var, fil
-  LOGICAL            :: exist_file
-!===============================================================================
-  modname='dynredem1'
-  fil=fichnom
+  CHARACTER(LEN=256) :: var, dum
+  LOGICAL            :: lread_inca
+!===============================================================================
+
+  modname='dynredem1'; fil=fichnom
   CALL err(NF90_OPEN(fil,NF90_WRITE,nid),"open",fil)
 
 !--- Write/extend time coordinate
   nb = nb + 1
-  CALL sav_var1("temps",[time],nb)
+  var="temps"
+  CALL err(NF90_INQ_VARID(nid,var,vID),"inq",var)
+  CALL err(NF90_PUT_VAR(nid,vID,[time]),"put",var)
   WRITE(lunout,*)TRIM(modname)//": Saving for ", nb, time
 
 !--- Rewrite control table (itaufin undefined in dynredem0)
   var="controle"
-  CALL get_var1(var,tab_cntrl); tab_cntrl(31)=DBLE(itau_dyn + itaufin)
   CALL err(NF90_INQ_VARID(nid,var,vID),"inq",var)
-  CALL NF95_PUT_VAR(nid,vID,tab_cntrl)
+  CALL err(NF90_GET_VAR(nid,vID,tab_cntrl),"get",var)
+  tab_cntrl(31)=DBLE(itau_dyn + itaufin)
+  CALL err(NF90_INQ_VARID(nid,var,vID),"inq",var)
+  CALL err(NF90_PUT_VAR(nid,vID,tab_cntrl),"put",var)
 
 !--- Save fields
-  CALL sav_var3("ucov",ucov)
-  CALL sav_var3("vcov",vcov)
-  CALL sav_var3("teta",teta)
-  CALL sav_var3("masse",masse)
-  CALL sav_var2("ps"   ,ps)
+  CALL dynredem_write_u(nid,"ucov" ,ucov ,llm)
+  CALL dynredem_write_v(nid,"vcov" ,vcov ,llm)
+  CALL dynredem_write_u(nid,"teta" ,teta ,llm)
+  CALL dynredem_write_u(nid,"masse",masse,llm)
+  CALL dynredem_write_u(nid,"ps"   ,ps   ,1)
 
 !--- Tracers in file "start_trac.nc" (added by Anne)
-  IF (type_trac == 'inca') THEN
-    fil="start_trac.nc"; INQUIRE(FILE=fil,EXIST=exist_file)
-    IF(.NOT.exist_file) CALL war(-1,"open",fil)
-  END IF
-  DO iq=1,nqtot; var=tname(iq)
-
-  !--- Usual case
-    IF(type_trac/='inca') THEN
-      CALL sav_var3(var,q(:,:,:,iq)); CYCLE
+  lread_inca=.FALSE.; fil="start_trac.nc"
+  IF(type_trac=='inca') INQUIRE(FILE=fil,EXIST=lread_inca)
+  IF(lread_inca) CALL err(NF90_OPEN(fil,NF90_NOWRITE,nid_trac),"open")
+
+!--- Save tracers
+  DO iq=1,nqtot; var=tname(iq); ierr=-1
+    IF(lread_inca) THEN                  !--- Possibly read from "start_trac.nc"
+      fil="start_trac.nc"
+      ierr=NF90_INQ_VARID(nid_trac,var,vID_trac)
+      dum='inq'; IF(ierr==NF90_NoErr) dum='fnd'
+      WRITE(lunout,*)msg(dum,var)
+
+
+      IF(ierr==NF90_NoErr) CALL dynredem_read_u(nid_trac,var,q(:,:,:,iq),llm)
     END IF
-
-  !--- Special case for INCA tracer read from "start_trac.nc"
-    IF(NF90_INQ_VARID(nid_trac,var,vID_trac)/=NF90_NoErr) THEN
-      CALL war(-1,"inq",var,fil)
-      CALL err(NF90_INQ_VARID(nid,var,vID),"inq",var,fil)
-      CALL NF95_PUT_VAR(nid,vID,q(:,:,:,iq))
-    ELSE
-      WRITE(lunout,*)TRIM(modname)//": <"//TRIM(var)//"> found in "//fil
-      CALL err(NF90_GET_VAR(nid_trac,vID_trac,trac_tmp),"get",var,fil)
-    END IF
-    CALL sav_var3(var,RESHAPE(trac_tmp,SHAPE=[iip1,jjp1,llm]))
+    fil=fichnom
+    CALL dynredem_write_u(nid,var,q(:,:,:,iq),llm)
   END DO
-  CALL err(NF90_CLOSE(nid),"close",fichnom)
-
-
-CONTAINS
-
-
-SUBROUTINE get_var1(var,v)
-  CHARACTER(LEN=*), INTENT(IN) :: var
-  REAL,             INTENT(OUT) :: v(:)
-  CALL err(NF90_INQ_VARID(nid,var,vID),"inq",var)
-  CALL err(NF90_GET_VAR(nid,vID,v),"get",var)
-END SUBROUTINE get_var1
-
-
-SUBROUTINE sav_var1(var,v,start)
-  CHARACTER(LEN=*),  INTENT(IN) :: var
-#ifdef NC_DOUBLE
-  DOUBLE PRECISION,  INTENT(IN) :: v(:)
-#else
-  REAL,              INTENT(IN) :: v(:)
-#endif
-  INTEGER, OPTIONAL, INTENT(IN) :: start
-  CALL err(NF90_INQ_VARID(nid,var,vID),"inq",var)
-  IF(PRESENT(start)) THEN
-    CALL NF95_PUT_VAR(nid,vID,v,start=[start])
-  ELSE
-    CALL NF95_PUT_VAR(nid,vID,v)
-  END IF
-END SUBROUTINE sav_var1
-
-
-SUBROUTINE sav_var2(var,v)
-  CHARACTER(LEN=*), INTENT(IN) :: var
-#ifdef NC_DOUBLE
-  DOUBLE PRECISION, INTENT(IN) :: v(:,:)
-#else
-  REAL,             INTENT(IN) :: v(:,:)
-#endif
-  CALL err(NF90_INQ_VARID(nid,var,vID),"inq",var)
-  CALL NF95_PUT_VAR(nid,vID,v)
-END SUBROUTINE sav_var2
-
-
-SUBROUTINE sav_var3(var,v)
-  CHARACTER(LEN=*), INTENT(IN) :: var
-#ifdef NC_DOUBLE
-  DOUBLE PRECISION, INTENT(IN) :: v(:,:,:)
-#else
-  REAL,             INTENT(IN) :: v(:,:,:)
-#endif
-
-print*,'var='//TRIM(var)
-print*,SHAPE(v)
-  CALL err(NF90_INQ_VARID(nid,var,vID),"inq",var)
-  CALL NF95_PUT_VAR(nid,vID,v)
-END SUBROUTINE sav_var3
-
-
-FUNCTION msg(typ,nam,fil)
-  IMPLICIT NONE
-  CHARACTER(LEN=256)           :: msg    !--- STANDARDIZED MESSAGE
-  CHARACTER(LEN=*), INTENT(IN) :: typ    !--- TYPE OF OPERATION
-  CHARACTER(LEN=*), INTENT(IN) :: nam    !--- FIELD NAME
-  CHARACTER(LEN=*), INTENT(IN) :: fil    !--- FILE  NAME
-  SELECT CASE(typ)
-    CASE('inq');   msg="Missing field <"//TRIM(nam)//">"
-    CASE('get');   msg="Reading failed for <"//TRIM(nam)//">"
-    CASE('open');  msg="Opening failed for <"//TRIM(nam)//">"
-    CASE('close'); msg="Closing failed for <"//TRIM(nam)//">"
-  END SELECT
-  msg=TRIM(modname)//": "//TRIM(msg)
-  IF(typ=="inq".AND.fil/="") msg=TRIM(msg)//" in file <"//TRIM(fil)//">"
-
-END FUNCTION msg
-
-
-SUBROUTINE err(ierr,typ,nam,fil)
-  IMPLICIT NONE
-  INTEGER,                    INTENT(IN) :: ierr   !--- NetCDF ERROR CODE
-  CHARACTER(LEN=*),           INTENT(IN) :: typ    !--- TYPE OF OPERATION
-  CHARACTER(LEN=*),           INTENT(IN) :: nam    !--- FIELD NAME
-  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: fil    !--- FILE  NAME
-  CHARACTER(LEN=256) :: file
-  IF(ierr==NF90_NoERR) RETURN
-  file=""; IF(PRESENT(fil)) file=fil
-  CALL ABORT_gcm(modname,msg(typ,nam,file),ierr)
-END SUBROUTINE err
-
-
-SUBROUTINE war(ierr,typ,nam,fil)
-  IMPLICIT NONE
-  INTEGER,                    INTENT(IN) :: ierr   !--- NetCDF ERROR CODE
-  CHARACTER(LEN=*),           INTENT(IN) :: typ    !--- TYPE OF OPERATION
-  CHARACTER(LEN=*),           INTENT(IN) :: nam    !--- FIELD NAME
-  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: fil    !--- FILE  NAME
-  CHARACTER(LEN=256) :: file
-  IF(ierr==NF90_NoERR) RETURN
-  file=""; IF(PRESENT(fil)) file=fil
-  WRITE(lunout,*)msg(typ,nam,file)
-END SUBROUTINE war
-
+  CALL err(NF90_CLOSE(nid),"close")
+  fil="start_trac.nc"
+  IF(lread_inca) CALL err(NF90_CLOSE(nid_trac),"close")
 
 END SUBROUTINE dynredem1
